Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa35w.bas                                                               *
'*                                                                           *
'* aISA-A35                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/03/11                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA35_DLL_NAME = "aisa35.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const AISA35_ERR_WRAPDLL = -1  ' bp[֐G[

'*****************************************************************************
'*    aisa35.dll[h                                                 *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa35wDllOpen() As Boolean

    Aisa35wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(AISA35_DLL_NAME)
    If hDLL = 0 Then Exit Function

    If Aisa35wGetDllExportFunc() = False Then
        Aisa35wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Aisa35wDllOpen = True

End Function

'*****************************************************************************
'*    aisa35.dllA[h                                             *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa35wDllClose() As Boolean

    Aisa35wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Aisa35wDllClose = False

End Function

'*****************************************************************************
'*    aISA-A35 DLL,Drṽo[Wԍ擾                               *
'*    pdwDllVer DLLo[Wԍi[                              *
'*        pdwDrvVer Drvo[Wԍi[                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa35wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean

    Aisa35wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Aisa35GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function

    Aisa35wGetVersion = True

End Function

'*****************************************************************************
'*    aISA-A35̔Cӂ̃foCX̎gp錾                               *
'*    pwLogSlot  gpfoCXi[                                  *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa35wCreate(pwLogSlot As Integer) As Boolean

    Aisa35wCreate = False

    If hDLL = 0 Then Exit Function

    If Aisa35Create(pwLogSlot) = 0 Then Exit Function

    Aisa35wCreate = True

End Function

'*****************************************************************************
'*    aISA-A35̔Cӂ̃foCX̎gpJ                               *
'*    wLogSlot gpfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa35wClose(wLogSlot As Integer) As Boolean

    Aisa35wClose = False

    If hDLL = 0 Then Exit Function

    If Aisa35Close(wLogSlot) = 0 Then Exit Function

    Aisa35wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlot ׂfoCX                                            *
'*        pres     \[Xi[\                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa35wGetResource(wLogSlot As Integer, pres As AISA35RESOURCE) As Boolean

    Aisa35wGetResource = False

    If hDLL = 0 Then Exit Function

    If Aisa35GetResource(wLogSlot, pres) = 0 Then Exit Function

    Aisa35wGetResource = True

End Function

'*****************************************************************************
'*    A/DTvO̎s                                              *
'*    wLogSlot       TvOfoCX                            *
'*        pcpara         TvOp[^                              *
'*        pwSamplingData TvOf[^                                  *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa35wStartSampling(wLogSlot As Integer, pcpara As AISA35PARA, pwSamplingData As Integer) As Boolean

    Aisa35wStartSampling = False

    If hDLL = 0 Then Exit Function

    If Aisa35StartSampling(wLogSlot, pcpara, pwSamplingData) = 0 Then Exit Function

    Aisa35wStartSampling = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gf[^                                       *
'*    wLogSlot  ͂foCX                                         *
'*        pbInValue ̓f[^i[                                         *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa35wInPort(wLogSlot As Integer, pbInValue As Byte) As Boolean

    Aisa35wInPort = False

    If hDLL = 0 Then Exit Function

    If Aisa35InPort(wLogSlot, pbInValue) = 0 Then Exit Function

    Aisa35wInPort = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gփf[^o                                         *
'*    wLogSlot  o͂foCX                                         *
'*        bOutValue o͂f[^                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa35wOutPort(wLogSlot As Integer, bOutValue As Byte) As Boolean

    Aisa35wOutPort = False

    If hDLL = 0 Then Exit Function

    If Aisa35OutPort(wLogSlot, bOutValue) = 0 Then Exit Function

    Aisa35wOutPort = True

End Function

'*****************************************************************************
'*    aISA-A35̃G[R[h                                             *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Aisa35wGetLastError(wLogSlot As Integer) As Long

    Aisa35wGetLastError = AISA35_ERR_WRAPDLL

    If hDLL = 0 Then Exit Function

    Aisa35wGetLastError = Aisa35GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Aisa35wGetDllExportFunc() As Boolean

    Dim pFunc As Long

    Aisa35wGetDllExportFunc = False

    ' Aisa35GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa35GetVersion")
    If pFunc = 0 Then Exit Function

    ' Aisa35Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa35Create")
    If pFunc = 0 Then Exit Function

    ' Aisa35Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa35Close")
    If pFunc = 0 Then Exit Function

    ' Aisa35GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa35GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa35StartSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa35StartSampling")
    If pFunc = 0 Then Exit Function

    ' Aisa35InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa35InPort")
    If pFunc = 0 Then Exit Function

    ' Aisa35OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa35OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa35GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa35GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa35wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
